package com.sw.patroleditor.controller;

import com.sw.patroleditor.common.ResultData;
import com.sw.patroleditor.controller.api.SystemApi;
import com.sw.patroleditor.exception.BusinessException;
import com.sw.patroleditor.exception.ErrorCode;
import com.sw.patroleditor.service.SystemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;

/**
 * Created by shiwn on 2024/5/29 16:19
 */
@RestController
@RequestMapping("system")
public class SystemController implements SystemApi {
    @Autowired
    private SystemService systemService;

    @Override
    @PostMapping("login")
    public ResultData login(@RequestBody Map map, HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (map.get("account") == null) {
            throw new BusinessException(ErrorCode.ACCOUNT_NULL);
        }
        if (map.get("passWord") == null) {
            throw new BusinessException(ErrorCode.PASSWORD_NULL);
        }
        String account = map.get("account").toString();
        String passWord = map.get("passWord").toString();
        return ResultData.success(systemService.login(account, passWord, request, response));
    }

    @Override
    @GetMapping("/quit")
    public ResultData quit(HttpServletRequest request) {
        request.getSession().removeAttribute("loginUserDTO");
        request.getSession().removeAttribute("loginUser");
        return ResultData.success("");
    }
}
