package com.sw.patroleditor.controller.api;

import com.sw.patroleditor.common.ResultData;
import com.sw.patroleditor.domain.vo.RobotModelVO;
import com.sw.patroleditor.domain.vo.RobotMoveCtrlVO;
import com.sw.patroleditor.domain.vo.RobotSpecialCtrlVO;
import com.sw.patroleditor.domain.vo.RobotToolCtrlVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.Map;

/**
 * 机器人控制 api
 * Created by shiwn on 2021/5/12 10:27
 */
@Api(tags = {"机器人控制接口"})
public interface RobotCtrlApi {

    @ApiOperation("特殊状态控制")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "vo", value = "数据", dataType = "RobotSpecialCtrlVO", required = true)
    })
    ResultData specialCtrl(@RequestBody RobotSpecialCtrlVO vo);

    @ApiOperation("机器人移动控制")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "vo", value = "数据", dataType = "RobotMoveCtrlVO", required = true)
    })
    ResultData robotMoveCtrl(@RequestBody RobotMoveCtrlVO vo);

    @ApiOperation("补光灯、雨刷控制")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "vo", value = "数据", dataType = "RobotToolCtrlVO", required = true)
    })
    ResultData toolCtrl(@RequestBody RobotToolCtrlVO vo);

    @ApiOperation("机器人模式切换")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "vo", value = "数据", dataType = "RobotModelVO", required = true)
    })
    ResultData modelChange(@RequestBody RobotModelVO vo);
}
