package com.sw.patroleditor.domain.dto;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.Date;

/**
 * @author machao
 * @version 1.0
 * @description: 用户表实体类
 * @date 2021/5/10 13:55
 */
@Data
@Accessors(chain = true)
@TableName("user")
public class UserDTO {

    @TableId(type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "用户名")
    private String account;

    @ApiModelProperty(value = "密码")
    private String password;

    @ApiModelProperty(value = "姓名")
    private String name;

    @ApiModelProperty(value = "手机号")
    private String mobile;

    @ApiModelProperty(value = "邮箱")
    private String email;

    @ApiModelProperty(value = "备注")
    private String note;

    @ApiModelProperty(value = "部门id")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private Integer deptId;

    @ApiModelProperty(value = "角色id")
    private Integer roleId;

    @ApiModelProperty(value = "登录ip")
    private String loginIp;

    @ApiModelProperty(value = "登录时间")
    private String loginTime;

    @ApiModelProperty(value = "账户状态 0:停用 1:启用")
    private Integer status;

    @ApiModelProperty(value = "信息提醒状态 0:关闭 1:接收短信 2:接收邮箱 3:全部接收")
    private Integer msgStatus;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    @ApiModelProperty(value = "创建人用户id")
    private Integer createUserId;

    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    @ApiModelProperty(value = "更新人用户id")
    private Integer updateUserId;

    @ApiModelProperty(value = "逻辑删除标志 Y:已删除 N:正常")
    private String delFlag;

    @ApiModelProperty(value = "app头像")
    private String icon;

}
