package com.sw.patroleditor.domain.model;

import lombok.Data;

@Data
public class BodyRequestModel {

    /**
     * 协议，http或者https
     */
    private String agreement = "http";
    /**
     * example 192.168.1.64
     */
    private String ip = "192.168.1.75";

    /**
     * 端口
     */
    private Integer port = 80;
    /**
     * channel
     */
    private Integer channel = 1;
    /**
     * 账号
     * example admin
     */
    private String username = "admin";

    /**
     * 原密码
     * example sunwin2015
     */
    private String password = "ubuntu123";

    /**
     * 除了协议、ip，端口后面的uri
     * example /ISAPI/System/TwowayAudio/channels
     */
    private String uri;

    /**
     * 请求参数
     */
    private String entity;


    /**
     * application/json
     * text/xml
     */
    private String type = "application/json";
}
