package com.sw.patroleditor.exception;

/**
 * 异常状态编码
 * Created by shiwn on 2021/1/12 11:33
 */
public enum ErrorCode {
    SUCCESS(0, "成功"),

    FAIL(1, "失败"),

    //    系统用户相关
    ACCOUNT_NOT_EXIST(1, "用户不存在"),

    ACCOUNT_NULL(1, "用户名不能为空"),

    ACCOUNT_DUPLICATE(1, "用户名重复"),

    MOBILE_DUPLICATE(1, "手机号重复"),

    LOGIN_ERROR(1, "用户名或密码错误"),

    LOGIN_FAIL(1, "登录失败"),

    LOGIN_INVALIDATION(1, "登录失效"),

    PASSWORD_ERROR(1, "密码错误"),

    PASSWORD_NULL(1, "请输入密码"),

    CONFIRM_PASSWORD_NULL(1, "请输入确认密码"),

    CONFIRM_PASSWORD_ERROR(1, "两次密码输入不一致"),

    //  机器人相关
    OPERATION_FAILED(1, "操作失败"),
    ROBOT_RETURN_NULL(1, "机器人无返回数据!"),


    //API通用状态码
    KEYID_ERROR(202, "无效key"),

    SNS_ERROR(202, "无效SNS"),

    ACCOUNT_PWD_ERROR(204, "用户名或密码错误"),

    GH_DATA_NULL(205, "返回结果为空"),

    PARAMETER_ERROR(402, "参数错误"),

    DATA_TOO_LARGE(1, "查询数据量太大,请缩小查询范围"),

    SERVER_ID_ERROR(403, "无权限访问");


    private int code;
    private String msg;

    ErrorCode(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public int getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }
}
