package com.sw.patroleditor.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.sw.patroleditor.domain.dto.UserDTO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Component;

/**
 * Created by shiwn on 2024/5/29 16:30
 */
@Component
public interface UserMapper extends BaseMapper<UserDTO> {
    /**
     * @Description: 获取用户信息 by 用户名 + 密码 （登录判断使用）
     * @Param: [username, password]
     * @Author: shiwn
     * @Date: 2020/7/31 9:30
     */
    @Select("select * from user where  (account = #{username} or mobile= #{username}) and password = #{password} and status = 1 and del_flag='N'")
    UserDTO findUserByNameAndPassword(@Param("username") String username, @Param("password") String password);
}
